import { IConfig, IStorageAdapter, Payload } from '../types';
import * as S3 from 'aws-sdk/clients/s3';
export declare class CloudStorage implements IStorageAdapter {
    readonly config: IConfig;
    readonly client: S3;
    constructor(config: IConfig);
    static init(config: IConfig): CloudStorage;
    head(path: string): Promise<object>;
    set(value: object, path: string, metadata?: {
        [key: string]: any;
    }): Promise<object>;
    get(path: string): Promise<Payload>;
    remove(path: string): Promise<import("aws-sdk/lib/request").PromiseResult<S3.DeleteObjectOutput, import("aws-sdk/lib/error").AWSError>>;
    copy(path: string, ETag: string, metadata?: {
        [key: string]: any;
    }): Promise<import("aws-sdk/lib/request").PromiseResult<S3.CopyObjectOutput, import("aws-sdk/lib/error").AWSError>>;
}
